using System;
using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;

namespace VamTastic
{
    public class Door : MVRScript
    {
        #region PluginInfo    
        public string pluginAuthor = "original script by Frief edited by VamTastic";
        public string pluginName = "Door";
        public string pluginVersion = "1.1";
        public string pluginDate = "21/07" + "/2021";
        public string pluginDescription = @"simple door ";
        #endregion

        #region Vars    



        public GameObject player;
        public GameObject Building;

        protected JSONStorableFloat ScrubA;


        private float previousValue1;

        private float previousZValue;
        private float currentZValue;

        public Transform door1;



        private static Atom currentAtom;
        private static string currentAtomName = "None";
        private static string tempAtomName = "None";

        #endregion

        public override void Init()
        {
            try
            {



                //**************  ScrubA
                ScrubA = new JSONStorableFloat("Door", 0f, 0f, 1.00f, false);
                RegisterFloat(ScrubA);
                CreateSlider(ScrubA, false);



            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        // Update is called with each rendered frame by Unity
        void Update()
        {
           
            var Slider1 = ScrubA.val;
            currentAtomName = "HeathersRoom";			
            


            // #VALUE currentAtomName
//            if (currentAtomName != "None")
            {

                // if not "None" check if it changed to prevouis Value
                //# VALUE tempAtomName
                if (tempAtomName != "HeathersRoom")
                {

                    // If changed store current selection in tempAtomName
                    findBuilding();
                    tempAtomName = "HeathersRoom";					

                }

                else

                {
                    tempAtomName = "HeathersRoom";
                    currentZValue = this.transform.position.x;
                    
                }					

                if (previousValue1 != Slider1)
                {
                    OnSliderChanged();
                }

            }

        }

        void OnSliderChanged()
        {
            

            {

                var Slider1 = ScrubA.val;
                var a = Slider1 - previousValue1;
               door1.transform.Rotate(Vector3.down * a * 90);
               previousValue1 = ScrubA.val;
            }

        }

        public void findBuilding()
        {

            if (currentAtomName == "None")
            {
                SuperController.LogError("No Room Asset is selected ");
            }

            Building = GameObject.Find("CustomUnityAsset");

            var findDoor = "reParentObject/object/rescaleObject/HeathersRoomDoor";

            door1 = containingAtom.transform.Find(findDoor);
            
            float yRotation = door1.transform.localRotation.y;

 //           ScrubA.val = yRotation;

            previousZValue = this.transform.position.x;

            if (Building != null)
            {
                


                if (door1 == null)
               {
                    SuperController.LogError("No child with the name " + findDoor + " attached to the player");
                }

            }

        }

    }
}